/*
 * OrthoCamera.cpp
 *
 *  Created on: Feb 8, 2009
 *      Author: sri
 */

#include "OrthoCamera.h"
#define ZOOMRATE 2
OrthoCamera::OrthoCamera() {
	resetCamera();
}

void OrthoCamera::resetCamera(){
	scrX=(float)scrWidth/2 -scaleX*treeCenterX;
	scrY=(float)scrHeight/2-scaleY*treeCenterY;
	focusX=iTranX(scrX)+treeCenterX;
	focusY=iTranY(scrY)+treeCenterY;
	
	//scrX=scrY=0;
	//focusX=focusY=0;
	minZoom=60;
	maxZoom=300;
	scaleX=scaleY=minZoom;
}

void OrthoCamera::setFocus(float x,float y){
	focusX=x;
	focusY=y;
}

Point OrthoCamera::getFocus(){
	return Point(focusX,focusY);
}

void OrthoCamera::setZoomLimits(float minz,float maxz){
	minZoom=minz;
	maxZoom=maxz;
}
void OrthoCamera::setTreeCenter(float x, float y){
	treeCenterX=x;
	treeCenterY=y;
}

void OrthoCamera::zoomIn(){
	if (scaleX<=maxZoom-ZOOMRATE){
		scaleX+=ZOOMRATE;
		scaleY=scaleX;
		scrX=scrX - focusX*ZOOMRATE;
		scrY=scrY - focusY*ZOOMRATE;
	}else{
		scrX=scrX - focusX*(maxZoom-scaleX);
		scrY=scrY - focusY*(maxZoom-scaleY);
		scaleX=scaleY=maxZoom;
	}
}
void OrthoCamera::zoomOut(){
	if (scaleX>=minZoom+ZOOMRATE){
		scaleX-=ZOOMRATE;
		scaleY=scaleX;
		scrX=scrX + focusX*ZOOMRATE;
		scrY=scrY + focusY*ZOOMRATE;
	}else{
		scrX=scrX + focusX*(scaleX-minZoom);
		scrY=scrY + focusY*(scaleX-minZoom);
		scaleX=scaleY=minZoom;
	}
}

void OrthoCamera::pan(float x,float y){
	scrX+=x;
	scrY+=y;
	resetFocus();
}

void OrthoCamera::resetFocus(){
	setFocus(iTranX(scrWidth/2),iTranY(scrHeight/2));
}

float OrthoCamera::tranX(float x){
	return x*scaleX +scrX;
}

float OrthoCamera::tranY(float y){
	return y*scaleY +scrY;
}

float OrthoCamera::iTranX(float x){
	return (x-scrX)/scaleX;
}

float OrthoCamera::iTranY(float y){
	return (y-scrY)/scaleY;
}

float OrthoCamera::getWidth(){
	return scrWidth;
}
float OrthoCamera::getHeight(){
	return scrHeight;
}

void OrthoCamera::setOrthographicProjection() {

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluOrtho2D(0, scrWidth, 0, scrHeight);
	glScalef(1, -1, 1);
	glTranslatef(0, -scrHeight, 0);
	glMatrixMode(GL_MODELVIEW);
}

void OrthoCamera::changeSize(int width, int height){
	if(height == 0) height = 1;
	scrWidth=width;
	scrHeight=height;
	scrX=(float)scrWidth/2 -scaleX*treeCenterX;
	scrY=(float)scrHeight/2-scaleY*treeCenterY;
	focusX=iTranX(scrX)+treeCenterX;
	focusY=iTranY(scrY)+treeCenterY;
}
