/*
 * OrthoCamera.h
 *
 *  Created on: Feb 8, 2009
 *      Author: sri
 */

#ifndef ORTHOCAMERA_H_
#define ORTHOCAMERA_H_

#include <GL/glut.h>
#include "PointList.h"

//this class controls the orthogonal viewport and sets the zoom level etc...
class OrthoCamera {
protected:
	float treeCenterX,treeCenterY;
	
	float scrX,scrY;
	float scaleX;
	float scaleY;
	int scrWidth, scrHeight;

	float focusX, focusY;

	float minZoom, maxZoom;

public:
	OrthoCamera();
	void setOrthographicProjection();
	void changeSize(int width, int height);
	void setZoomLimits(float minz,float maxz);
	void setFocus(float x,float y);
	Point getFocus();
	void resetFocus();
	void setTreeCenter(float x, float y);
	
	void resetCamera();
	void zoomIn();
	void zoomOut();
	void pan(float x,float y);

	float getWidth();
	float getHeight();

	float tranX(float x);
	float tranY(float y);
	float iTranX(float x);
	float iTranY(float y);

};

#endif /* ORTHOCAMERA_H_ */
