/*
 * PointList.h
 *
 *  Created on: Feb 5, 2009
 *      Author: sri
 */

#ifndef POINTLIST_H_
#define POINTLIST_H_

#include <list>
using namespace std;

class QuadTree;//forward definition

struct Point{
public:
	float x,y;
	float vx,vy;
	float fx,fy;
	Point(){
		x=y=0.0;
		vx=vy=fx=fy=0.0;
	}
	Point(float x, float y){
		this->x=x;
		this->y=y;
	}
	Point(const Point& p){
		this->x=p.x;
		this->y=p.y;
	}
};

class PointList{
protected:
	list<Point> points;
public:
	friend class QuadTree;

	PointList();
	void clearList();
	void addPoint(const Point&);
	void addPoint(float x, float y);
	void append(PointList& p);
	void removePoint(list<Point>::iterator i);
	unsigned int getNumPoints();

	list<Point>::iterator getBegin();
	list<Point>::iterator getEnd();

	virtual ~PointList();
};

#endif /* POINTLIST_H_ */
