/*
 * VectorLine.h
 *
 *  Created on: Feb 9, 2009
 *      Author: sri
 */

#ifndef VECTORLINE_H_
#define VECTORLINE_H_

class VectorLine {
public:
	//p+td is the vector (t is a parameter)
	float px,py;
	float dx,dy;

	static float delta;

	VectorLine();
	VectorLine(const VectorLine& v);
	VectorLine(float x1,float y1,float x2,float y2);//dx=x2-x1, dy=y2-y1
	void setLine(float x1,float y1,float x2,float y2);
	void setDirection(float dx,float dy);
	
	//the 2 functions below return the vector parameter t, not the actual intercept point.
	//to find the actual point, pass the return value to evaluateX and evaluateY
	float hIntercept(float xval) const;//intercept with horizontal line
	float vIntercept(float yval) const;//intercept with vertical line

	float evaluateX(float t) const;
	float evaluateY(float t) const;
	
	float perpendicularDistance(float x, float y) const;
};

#endif /* VECTORLINE_H_ */
